//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
co_i_cuentasanuales.qs  -  description
-------------------
begin                : vie nov 09 2007
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function validateForm()
  {
    return this.ctx.validateForm1();
  }
  function bufferChanged(fN: String)
  {
    return this.ctx.oficial_bufferChanged(fN);
  }
  function recalcularDatos()
  {
    return this.ctx.recalcularDatos2();
  }
  function filtroDatos()
  {
    return this.ctx.filtroDatos3();
  }
}
const iface = new interna(this);
/** \C
Si no existe otro ejercicio ms antiguo que el actual, los campos de ejercicio anterior aparecern deshabilitados. Si existe algn ejercicio previo al actual, aparecer como ejercicio anterior en el formulario aquel ejercicio ms reciente de entre los pasados.
\end */
function init0()
{
  this.child("fdbEjercicioAct").setFilter("plancontable = '08'");
  this.child("fdbEjercicioAnt").setFilter("plancontable = '08'");
  connect(this.child("pbnRecalcular"), "clicked()", this, "iface.recalcularDatos");
  this.iface.filtroDatos();
}
/** \C
La fecha de inicio del perodo de un ejercicio no puede ser posterior que la fecha de fin
Las fechas deben estar comprendidas dentro del perodo de cada ejercicio
Para poder realizar el balance sobre ms de un ejercicio es necesario que ambos tengan igual nmero de dgitos en las subcuentas
\end */
function validateForm1()
{
  var fechaDesde: String;
  var fechaHasta: String;
  var fechaInicio: String;
  var fechaFin: String;
  var fechaInicioAct: String;
  var fechaFinAnt: String;
  var util = new FLUtil();
  var q = new FLSqlQuery();
  var ejercicioAct = this.child("fdbEjercicioAct").value();
  if (!ejercicioAct)
    return true;
  fechaDesde = this.child("fdbFechaDesdeAct").value();
  fechaHasta = this.child("fdbFechaHastaAct").value();
  if (util.daysTo(fechaDesde, fechaHasta) < 0) {
    MessageBox.critical(util.translate("scripts", "La fecha de inicio del ejercicio actual debe ser menor que la de fin"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  q.setTablesList("ejercicios");
  q.setSelect("fechainicio, fechafin");
  q.setFrom("ejercicios");
  q.setWhere("codejercicio = '" + ejercicioAct + "';");
  q.exec();
  if (q.next()) {
    fechaInicio = q.value(0);
    fechaFin = q.value(1);
    fechaFinAnt = fechaFin;
  }
  if ((util.daysTo(fechaHasta, fechaFin) < 0) || (util.daysTo(fechaDesde, fechaInicio) > 0)) {
    MessageBox.critical(util.translate("scripts", "Las fechas de inicio y fin del ejercicio actual deben estar dentro del propio intervalo del ejercicio"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  var ejercicioAnt = this.child("fdbEjercicioAnt").value();
  if (!ejercicioAnt)
    return true;
  if (!flcontinfo.iface.pub_comprobarConsolidacion(ejercicioAct, ejercicioAnt)) {
    MessageBox.critical(util.translate("scripts", "Las subcuentas de los ejercicios deben tener la misma longitud"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  fechaDesde = this.child("fdbFechaDesdeAnt").value();
  fechaHasta = this.child("fdbFechaHastaAnt").value();
  if (util.daysTo(fechaDesde, fechaHasta) < 0) {
    MessageBox.critical(util.translate("scripts", "La fecha de inicio del ejercicio anterior debe ser menor que la de fin"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  q.setTablesList("ejercicios");
  q.setSelect("fechainicio, fechafin");
  q.setFrom("ejercicios");
  q.setWhere("codejercicio = '" + ejercicioAnt + "';");
  q.exec();
  if (q.next()) {
    fechaInicio = q.value(0);
    fechaFin = q.value(1);
    fechaFinAnt = fechaFin;
  }
  if ((util.daysTo(fechaHasta, fechaFin) < 0) || (util.daysTo(fechaDesde, fechaInicio) > 0)) {
    MessageBox.critical(util.translate("scripts", "Las fechas de inicio y fin del ejercicio anterior deben estar dentro del propio intervalo del ejercicio"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return false;
  }
  return true;
}
function recalcularDatos2()
{
  var cursor = this.cursor();
  var util = new FLUtil();
  if (cursor.modeAccess() == cursor.Insert) {
    var curD = this.child("tdbDatos08").cursor();
    curD.setModeAccess(curD.Insert);
    if (!curD.commitBufferCursorRelation())
      return;
  }
  this.child("tdbDatos08").cursor().setMainFilter("");
  flcontinfo.iface.recalcularDatosBalance(cursor);
  this.iface.filtroDatos();
  MessageBox.information(util.translate("scripts", "Se recalcularon los datos del balance"), MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
}
function filtroDatos3()
{
  var filtro = "";
  switch (this.cursor().valueBuffer("tipo")) {
    case "Situacion":
      filtro = "codbalance LIKE 'A-%' OR codbalance LIKE 'P-%'"
               break;
    case "Perdidas y ganancias":
      filtro = "codbalance LIKE 'PG-%'"
               break;
      filtro = "codbalance LIKE 'IG-%'"
               break;
  }
  //  this.child("tdbDatos08").cursor().setMainFilter(filtro);
  this.child("tdbDatos08").refresh();
  this.child("tdbSubtotales").refresh();
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
