//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
i_masteralbaranesprov.qs  -  description
-------------------
begin                : lun abr 26 2004
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function lanzar()
  {
    return this.ctx.lanzar1();
  }
  function obtenerOrden(nivel: Number, cursor: FLSqlCursor)
  {
    return this.ctx.obtenerOrden2(nivel, cursor);
  }
  function comprobarTodosAsientos()
  {
    return this.ctx.comprobarTodosAsientos3();
  }
}
const iface = new interna(this);
/** \C El botn de impresin lanza el informe
\end */
function init0()
{
  this.iface.comprobarTodosAsientos();
  connect(this.child("toolButtonPrint"), "clicked()", this, "iface.lanzar()");
}
/** \D Lanza el informe
\end */
function lanzar1()
{
  var cursor = this.cursor();
  if (!cursor.isValid())
    return;
  /** \D Lee el valor del campo tipo para establecer el nombre del report (archivo .kut) que ser llamado en la ejecucin del informe
  \end */
  var tipoInforme = cursor.valueBuffer("tipo");
  var nombreInforme = cursor.action();
  var nombreReport = nombreInforme;
  switch (tipoInforme) {
    case "Borrador":
      nombreReport = nombreReport + "_b";
      break;
    case "Analitico":
      nombreReport = nombreReport + "_a";
      break;
    case "Oficial":
      nombreReport = nombreReport + "_o";
      break;
    case "Oficial mensual":
      nombreReport = nombreReport + "_om";
      break;
  }
  /** \D Si el informe incluye datos de I.V.A. se aade '_iva' al final del nombre del reporte
  \end */
  if (cursor.valueBuffer("datosIva") == 1)
    nombreReport = nombreReport + "_iva";
  var orderBy = "";
  /** \D Si el informe se debe agrupar por meses se aade '_mes' al final del nombre del reporte
  \end */
  if (cursor.valueBuffer("agruparmeses") == 1) {
    nombreReport = nombreReport + "_mes";
    nombreInforme = nombreInforme + "_mes";
    orderBy = "co_asientos.fecha";
  }
  /** \D Se aade un ORDER BY a la consulta en funcin de los niveles de ordenamiento seleccionados
  \end */
  var o = "";
  for (var i = 1; i <= 3; i++) {
    o = this.iface.obtenerOrden(i, cursor);
    if (o) {
      if (orderBy == "")
        orderBy = o;
      else
        orderBy += ", " + o;
    }
  }
  flcontinfo.iface.pub_lanzarInforme(cursor, nombreInforme, nombreReport, orderBy, "", "", cursor.valueBuffer("id"));
}
/** \D Devuelve un criterio de orden para el informe en base a su nivel. Si el orden est marcado como descendente, se aade DESC al valor devuelto. Se utiliza para crear la clusula ORDER BY de la consulta del informe
@param nivel Nivel de ordenamiento (1, 2, 3...)
@param cursor Cursor sobre la tabla de informes de diario
@return Criterio de ordenacin (y opcionalmente DESC).
*/
function obtenerOrden2(nivel: Number, cursor: FLSqlCursor)
{
  var ret = "";
  var orden = cursor.valueBuffer("orden" + nivel.toString());
  switch (orden) {
    case "Asiento":
      ret += "co_asientos.numero";
      break;
    case "Fecha":
      ret += "co_asientos.fecha";
      break;
    case "Subcuenta":
      ret += "co_subcuentas.codsubcuenta";
      break;
  }
  if (ret != "") {
    var tipoOrden = cursor.valueBuffer("tipoorden" + nivel.toString());
    if (tipoOrden == "Descendente")
      ret += " DESC";
  }
  return ret;
}
/** \D Si est marcada la opcin --todosasientos-- se busca el mayor y el menor
\end */
function comprobarTodosAsientos3()
{
  var q = new FLSqlQuery();
  var curDiario = new FLSqlCursor("co_i_diario");
  curDiario.select("1=1");
  while (curDiario.next()) {
    if (!curDiario.valueBuffer("todosasientos")) continue;
    q.setTablesList("co_asientos");
    q.setSelect("MIN(numero), MAX(numero)");
    q.setFrom("co_asientos");
    q.setWhere("codejercicio = '" +
               curDiario.valueBuffer("i_co__subcuentas_codejercicio") + "'");
    if (!q.exec()) continue;
    if (!q.first()) continue;
    curDiario.setModeAccess(curDiario.Edit);
    curDiario.refreshBuffer();
    curDiario.setValueBuffer("d_co__asientos_numero", q.value(0));
    curDiario.setValueBuffer("h_co__asientos_numero", q.value(1));
    curDiario.commitBuffer();
  }
  this.child("tableDBRecords").refresh();
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
