//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
co_amortizaciones.qs  -  description
-------------------
begin                : vie dic 28 2007
copyright            : (C) 2007 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  var bloqImporte: Boolean;
  var bloqPorcentaje: Boolean;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function validateForm()
  {
    return this.ctx.validateForm1();
  }
  function calculateField(fN: String)
  {
    return this.ctx.calculateField2(fN);
  }
  function bufferChanged(fN)
  {
    return this.ctx.bufferChanged3(fN);
  }
  function commonCalculateField(fN: String, cursor: FLSqlCursor)
  {
    return this.ctx.commonCalculateField4(fN, cursor);
  }
  function pub_commonCalculateField(fN: String, cursor: FLSqlCursor)
  {
    return this.commonCalculateField(fN, cursor);
  }
}
const iface = new interna(this);
function init0()
{
  var util = new FLUtil();
  var cursor = this.cursor();
  if (cursor.modeAccess() == cursor.Insert) {
    this.child("fdbFechaInicio").setValue(this.iface.calculateField("fechainicio"));
    this.child("fdbFechaFin").setValue(this.iface.calculateField("fechafin"));
    this.child("fdbImporte").setValue(this.iface.calculateField("importeinicio"));
    this.cursor().setValueBuffer("acumulado", this.iface.calculateField("acumulado"));
    this.cursor().setValueBuffer("resto", this.iface.calculateField("resto"));
    this.cursor().setValueBuffer("porcentaje", this.iface.calculateField("porcentaje"));
  }
  this.iface.bloqImporte = false;
  this.iface.bloqPorcentaje = false
                              connect(cursor, "bufferChanged(QString)", this, "iface.bufferChanged");
}
function validateForm1()
{
  var util = new FLUtil;
  var cursor = this.cursor();
  if (cursor.valueBuffer("resto") < 0) {
    MessageBox.warning(util.translate("scripts", "El importe a amortizar no puede ser mayor que la cantidad pendiente de amortizar."), MessageBox.Ok, MessageBox.NoButton);
    return false;
  }
  var fechaInicio = cursor.valueBuffer("fechainicio");
  var fechaFin = cursor.valueBuffer("fechafin");
  var fecha = cursor.valueBuffer("fecha");
  var ultimaFechaFin = util.sqlSelect("co_dotaciones", "MAX(fechafin)", "codamortizacion = '" + this.cursor().valueBuffer("codamortizacion") + "' AND iddotacion <> " + cursor.valueBuffer("iddotacion"));
  if (!ultimaFechaFin)
    ultimaFechaFin = cursor.cursorRelation().valueBuffer("fecha");
  if (util.daysTo(ultimaFechaFin, fechaInicio) < 0) {
    MessageBox.warning(util.translate("scripts", "La fecha de inicio debe ser mayor que la fecha de adquisicin y la fecha de fin de la ltima dotacin"), MessageBox.Ok, MessageBox.NoButton);
    return false;
  }
  if (util.daysTo(fechaInicio, fechaFin) <= 0) {
    MessageBox.warning(util.translate("scripts", "La fecha de fin debe ser mayor que la fecha de inicio"), MessageBox.Ok, MessageBox.NoButton);
    return false;
  }
  if (util.daysTo(fechaInicio, fecha) < 0 || util.daysTo(fecha, fechaFin) < 0) {
    MessageBox.warning(util.translate("scripts", "La fecha del asiento debe estar comprendida en el intervalo de fechas de la dotacin"), MessageBox.Ok, MessageBox.NoButton);
    return false;
  }
  return true;
}
function calculateField2(fN)
{
  var util = new FLUtil;
  var res: Number;
  var cursor = this.cursor();
  switch (fN) {
    case "X": {
      break;
    }
    default: {
      res = this.iface.commonCalculateField(fN, cursor);
    }
  }
  return res;
}
function bufferChanged3(fN)
{
  var util = new FLUtil();
  switch (fN) {
    case "porcentaje": {
      if (!this.iface.bloqImporte) {
        this.iface.bloqImporte = true;
        this.cursor().setValueBuffer("importe", this.iface.calculateField("importe"));
        this.iface.bloqImporte = false;
      }
      break;
    }
    case "importe": {
      if (!this.iface.bloqImporte) {
        this.iface.bloqImporte = true;
        this.cursor().setValueBuffer("porcentaje", this.iface.calculateField("porcentaje"));
        this.iface.bloqImporte = false;
      }
      this.cursor().setValueBuffer("acumulado", this.iface.calculateField("acumulado"));
      break;
    }
    case "acumulado": {
      this.cursor().setValueBuffer("resto", this.iface.calculateField("resto"));
      break;
    }
  }
}
function commonCalculateField4(fN: String, cursor: FLSqlCursor)
{
  var util = new FLUtil;
  var res: Number;
  switch (fN) {
    case "importe": {
      var valorAmortizable: Number;
      if (cursor.cursorRelation()) {
        valorAmortizable = parseFloat(cursor.cursorRelation().valueBuffer("valoramortizable"));
      } else {
        valorAmortizable = parseFloat(util.sqlSelect("co_amortizaciones", "valoramortizable", "codamortizacion = '" + cursor.valueBuffer("codamortizacion") + "'"));
      }
      res = (parseFloat(cursor.valueBuffer("porcentaje")) * valorAmortizable) / 100;
      break;
    }
    case "porcentaje": {
      var valorAmortizable: Number;
      if (cursor.cursorRelation()) {
        valorAmortizable = parseFloat(cursor.cursorRelation().valueBuffer("valoramortizable"));
      } else {
        valorAmortizable = parseFloat(util.sqlSelect("co_amortizaciones", "valoramortizable", "codamortizacion = '" + cursor.valueBuffer("codamortizacion") + "'"));
      }
      res = (parseFloat(cursor.valueBuffer("importe")) * 100) / valorAmortizable;
      break;
    }
    case "acumulado": {
      res = parseFloat(util.sqlSelect("co_dotaciones", "acumulado", "codamortizacion = '" + cursor.valueBuffer("codamortizacion") + "' AND iddotacion <> " + cursor.valueBuffer("iddotacion") + " ORDER BY fechafin DESC"));
      if (!res) {
        if (cursor.cursorRelation()) {
          res = parseFloat(cursor.cursorRelation().valueBuffer("totalamortizado"));
        } else {
          res = parseFloat(util.sqlSelect("co_amortizaciones", "totalamortizado", "codamortizacion = '" + cursor.valueBuffer("codamortizacion") + "'"));
        }
      }
      if (!res || isNaN(res)) {
        res = 0;
      }
      res += parseFloat(cursor.valueBuffer("importe"));
      break;
    }
    case "resto": {
      var valorAmortizable: Number;
      if (cursor.cursorRelation()) {
        valorAmortizable = parseFloat(cursor.cursorRelation().valueBuffer("valoramortizable"));
      } else {
        valorAmortizable = parseFloat(util.sqlSelect("co_amortizaciones", "valoramortizable", "codamortizacion = '" + cursor.valueBuffer("codamortizacion") + "'"));
      }
      res = valorAmortizable - parseFloat(cursor.valueBuffer("acumulado"));
      break;
    }
    case "fechainicio": {
      var fechaInicio = util.sqlSelect("co_dotaciones", "fechafin", "codamortizacion = '" + cursor.valueBuffer("codamortizacion") + "' AND iddotacion <> " + cursor.valueBuffer("iddotacion") + " ORDER BY fechafin DESC");
      if (!fechaInicio) {
        if (cursor.cursorRelation()) {
          fechaInicio = cursor.cursorRelation().valueBuffer("fecha");
        } else {
          fechaInicio = util.sqlSelect("co_amortizaciones", "fecha", "codamortizacion = '" + cursor.valueBuffer("codamortizacion") + "'");
        }
      } else {
        fechaInicio = util.addDays(fechaInicio, 1);
      }
      res = fechaInicio;
      break;
    }
    case "fechafin": {
      var periodo: String;
      if (cursor.cursorRelation()) {
        periodo = cursor.cursorRelation().valueBuffer("periodo");
      } else {
        periodo = util.sqlSelect("co_amortizaciones", "periodo", "codamortizacion = '" + cursor.valueBuffer("codamortizacion") + "'");
      }
      res = formRecordco_amortizaciones.iface.pub_calcularFechaFinPeriodo(cursor.valueBuffer("fechainicio"), periodo);
      break;
    }
    case "importeinicio": {
      var importe: Number;
      if (!util.sqlSelect("co_dotaciones", "iddotacion", "codamortizacion = '" + cursor.valueBuffer("codamortizacion") + "' AND iddotacion <> " + cursor.valueBuffer("iddotacion"))) {
        if (cursor.cursorRelation()) {
          importe = cursor.cursorRelation().valueBuffer("amorprimerperiodo");
        } else {
          importe = util.sqlSelect("co_amortizaciones", "amorprimerperiodo", "codamortizacion = '" + cursor.valueBuffer("codamortizacion") + "'");
        }
      } else {
        var pendiente: Number;
        if (cursor.cursorRelation()) {
          pendiente = parseFloat(cursor.cursorRelation().valueBuffer("pendiente"));
          importe = cursor.cursorRelation().valueBuffer("amorperiodo");
        } else {
          pendiente = util.sqlSelect("co_amortizaciones", "pendiente", "codamortizacion = '" + cursor.valueBuffer("codamortizacion") + "'");
          importe = util.sqlSelect("co_amortizaciones", "amorperiodo", "codamortizacion = '" + cursor.valueBuffer("codamortizacion") + "'");
        }
        if (parseFloat(pendiente) <= parseFloat(importe)) {
          importe = pendiente;
        }
      }
      res = importe;
      break;
    }
  }
  return res;
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
