//// AbanQ Roller 2.4.0
var form = this;
/***************************************************************************
flfacturac.qs  -  description
-------------------
begin                : lun abr 26 2004
copyright            : (C) 2004 by InfoSiAL S.L.
email                : mail@infosial.com
***************************************************************************/
/***************************************************************************
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
***************************************************************************/
class interna
{
  var ctx;
  var posActualPuntoSubcuenta: Number;
  var ejercicioActual: String;
  var longSubcuenta: Number;
  var bloqueoSubcuenta: Boolean;
  function interna(context)
  {
    this.ctx = context;
  }
  function init()
  {
    this.ctx.init0();
  }
  function validateForm()
  {
    return this.ctx.validateForm1();
  }
  function calculateField(fN: String)
  {
    return this.ctx.calculateField2(fN);
  }
  function desconexion()
  {
    return this.ctx.desconexion3();
  }
  function bufferChanged(fN)
  {
    return this.ctx.bufferChanged4(fN);
  }
  function habilitarIVA()
  {
    return this.ctx.habilitarIVA5();
  }
  function verAsiento()
  {
    return this.ctx.verAsiento6();
  }
  function validarSubcuenta()
  {
    return this.ctx.validarSubcuenta7();
  }
}
const iface = new interna(this);
/** \C
El cuadro I.V.A. permanecer por defecto inhabilitado. Si la cuenta es de I.V.A. se habilitar el marco de I.V.A.
En modo insercin la divisa asignada ser la divisa por defecto de la empresa. La subcuenta toma como prefijo el valor de la cuenta asociada
En modo edicin la cuenta aparecer inhabilitada
\end */
function init0()
{
  var util = new FLUtil();
  var cursor = this.cursor();
  this.iface.ejercicioActual = flfactppal.iface.pub_ejercicioActual();
  this.iface.longSubcuenta = util.sqlSelect("ejercicios", "longsubcuenta",  "codejercicio = '" + this.iface.ejercicioActual + "'");
  this.iface.posActualPuntoSubcuenta = -1;
  this.iface.bloqueoSubcuenta = false;
  this.iface.habilitarIVA();
  switch (cursor.modeAccess()) {
    case cursor.Insert:
      cursor.setValueBuffer("codejercicio", this.iface.ejercicioActual);
      this.child("fdbCodDivisa").setValue(util.sqlSelect("empresa", "coddivisa", "1 = 1"));
      break;
    case cursor.Edit:
      this.child("fdbIdCuenta").setDisabled(true);
      this.child("fdbCodCuenta").setDisabled(true);
      this.child("fdbCodSubcuenta").setDisabled(true);
      break;
  }
  this.child("fdbIdCuenta").setFilter("codejercicio = '" + this.iface.ejercicioActual + "'");
  this.child("tdbPartidas").setReadOnly(true);
  connect(cursor, "bufferChanged(QString)", this, "iface.bufferChanged");
  connect(form, "closed()", this, "iface.desconexion");
  connect(this.child("pbnVerAsiento"), "clicked()", this, "iface.verAsiento");
}
function calculateField2(fN)
{
  var util = new FLUtil();
  var res;
  var cursor = this.cursor();
  switch (fN) {
      /** \D Toma como prefijo el nmero de cuenta a la que pertenece
      \end */
    case "codsubcuenta":
      res = cursor.valueBuffer("codcuenta");
      break;
      /** \D Busca el idcuenta correspondiente al cdigo de cuenta y ejercicio actuales
      \end */
    case "idcuenta":
      res = util.sqlSelect("co_cuentas", "idcuenta",
                           "codcuenta = '" + cursor.valueBuffer("codcuenta") + "'" +
                           " AND codejercicio = '" + this.iface.ejercicioActual + "'");
      break;
  }
  return res;
}
function validateForm1()
{
  var cursor = this.cursor();
  var util = new FLUtil();
  if (!this.iface.validarSubcuenta()) {
    return false;
  }
  /** \C
  El cdigo de subcuenta tendr como prefijo el cdigo de la cuenta
  \end */
  return true;
}
function desconexion3()
{
  disconnect(this.cursor(), "bufferChanged(QString)", this, "iface.bufferChanged");
}
function bufferChanged4(fN)
{
  var cursor = this.cursor();
  switch (fN) {
      /*U Al cambiar --codcuenta--, si la cuenta es de I.V.A. y no existen partidas asociadas a la subcuenta, se habilitar el marco de I.V.A.
      \end */
    case "codcuenta":
      this.child("fdbCodSubcuenta").setValue(this.iface.calculateField("codsubcuenta"));
      var idCuenta = this.iface.calculateField("idcuenta");
      if (idCuenta) this.child("fdbIdCuenta").setValue(idCuenta);
      this.iface.habilitarIVA();
      break;
      /*U Al introducir --codsubcuenta--, si el usuario pulsa la tecla del punto '.', la subcuenta se informa automaticamente con el cdigo de cuenta ms tantos ceros como sea necesario para completar la longitud de subcuenta asociada al ejercicio actual.
      \end */
    case "codsubcuenta":
      if (!this.iface.bloqueoSubcuenta) {
        this.iface.bloqueoSubcuenta = true;
        this.iface.posActualPuntoSubcuenta = flcontppal.iface.pub_formatearCodSubcta(this, "fdbCodSubcuenta", this.iface.longSubcuenta, this.iface.posActualPuntoSubcuenta);
        this.iface.bloqueoSubcuenta = false;
      }
      break;
  }
}
/** \D Si la cuenta es de I.V.A. y no existen partidas asociadas a la subcuenta, se habilitar el marco de I.V.A.
\end */
function habilitarIVA5()
{
  var util = new FLUtil();
  var cursor = this.cursor();
  if (util.sqlSelect("co_cuentas", "idcuentaesp",
                     "idcuenta = '" + cursor.valueBuffer("idcuenta") + "'" +
                     " AND (idcuentaesp = 'IVASOP' OR idcuentaesp = 'IVAREP')")) {
    this.child("fdbCodImpuesto").setDisabled(false);
    this.child("fdbIVA").setDisabled(false);
    this.child("fdbRecargo").setDisabled(false);
    return;
  }
  this.child("fdbCodImpuesto").setValue("");
  this.child("fdbIVA").setValue("");
  this.child("fdbRecargo").setValue("");
  this.child("fdbCodImpuesto").setDisabled(true);
  this.child("fdbIVA").setDisabled(true);
  this.child("fdbRecargo").setDisabled(true);
}
function verAsiento6()
{
  var util = new FLUtil();
  var curAsiento = new FLSqlCursor("co_asientos");
  var curPartidas = this.child("tdbPartidas").cursor();
  var idAsiento = curPartidas.valueBuffer("idasiento");
  if (!idAsiento || idAsiento == 0) {
    MessageBox.information(util.translate("MetaData", "No hay ninguna partida seleccionada"),
                           MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
    return;
  }
  curAsiento.select("idasiento = " + idAsiento);
  if (curAsiento.first()) {
    curAsiento.browseRecord();
  }
}
function validarSubcuenta7()
{
  var cursor = this.cursor();
  var util = new FLUtil();
  /** \C
  La longitud del cdigo de subcuenta debe coincidir con la longitud de subcuenta asignada al ejercicio actual
  \end */
  var codSubcuenta = cursor.valueBuffer("codsubcuenta");
  if (cursor.modeAccess() == cursor.Insert) {
    if (codSubcuenta && codSubcuenta != "") {
      if (codSubcuenta.length != this.iface.longSubcuenta) {
        MessageBox.warning(util.translate("MetaData", "El cdigo de subcuenta debe tener la longitud establecida para el ejercicio actual: ") + this.iface.longSubcuenta, MessageBox.Ok, MessageBox.NoButton, MessageBox.NoButton);
        return false;
      }
    }
  }
  var codCuenta = cursor.valueBuffer("codcuenta");
  if (util.sqlSelect("co_cuentas", "codcuenta", "idcuenta = " + cursor.valueBuffer("idcuenta")) != codCuenta) {
    MessageBox.warning(util.translate("MetaData", "El cdigo de cuenta no existe o no coincide con el idendentificador interno, borre dicho cdigo y vulvalo a escribir"), MessageBox.Ok, MessageBox.NoButton);
    return false;
  }
  var codSubcuenta = cursor.valueBuffer("codsubcuenta");
  if (codCuenta && codCuenta != "" && codSubcuenta && codSubcuenta != "") {
    if (!codSubcuenta.startsWith(codCuenta)) {
      MessageBox.warning(util.translate("MetaData", "El cdigo de subcuenta debe comenzar por el cdigo de su cuenta asociada"), MessageBox.Ok, MessageBox.NoButton);
      return false;
    }
  }
  return true;
}
/***********************************************************************
**
** Para aadir cambios personalizados se debe heredar de la clase
** 'CustomChanges' e implementar esos cambios en las clases derivadas.
**
** AVISO!! Todos cambios realizados fuera de la clase CustomChanges
** y que modifiquen la clase interna con la versin oficial,
** se perdern en posteriores actualizaciones ofrecidas por InfoSiAL.
**
************************************************************************/
class CustomChanges extends interna
{
  function CustomChanges(context)
  {
    interna(context);
  }
}
